package com.bjlt.spider.dao;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.entity.*;
import com.bjlt.spider.util.CurrencyUtils;
import com.bjlt.spider.util.MethodType;
import com.bjlt.spider.util.RespCode;
import com.bjlt.spider.util.RespEntity;
import com.gargoylesoftware.htmlunit.*;
import com.gargoylesoftware.htmlunit.html.*;
import com.gargoylesoftware.htmlunit.javascript.host.speech.SpeechSynthesisUtterance;
import com.gargoylesoftware.htmlunit.util.Cookie;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.luyn.core.StringUtil;
import com.luyn.date.DatePattren;
import com.luyn.date.DateUtil;
import com.luyn.enums.HttpRequestMethod;
import com.luyn.http.httpclient.*;
import com.luyn.http.okhttp.OkHttpDownLoader;
import com.luyn.http.okhttp.request.PostRequest;
import com.luyn.http.okhttp.response.HttpResponse;
import com.luyn.http.proxy.ProxyPojo;
import com.luyn.io.FileUtil;
import com.luyn.jdbc.JDBCUtil;
import javafx.scene.chart.ValueAxis;
import lombok.extern.slf4j.Slf4j;
import okhttp3.Headers;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Repository;
import org.springframework.web.method.annotation.ModelAttributeMethodProcessor;

import javax.print.DocFlavor;
import javax.swing.text.StyledEditorKit;
import java.io.IOException;
import java.lang.invoke.VolatileCallSite;
import java.math.BigDecimal;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.*;

/**
 * auth : luyanan0718@163.com
 * com.bjlt.spider.dao
 * CreateTime:2017/10/23-9:57
 * introduce:
 * 亚航   web 端的一些 操作
 **/


@Slf4j
@Repository
public class AirasiaWebDAO {

    @Autowired
    private IpDao ipDao;


    /**
     * 提交联系人信息和乘客信息
     *
     * @param html               页面内容，主要用来获取一些参数
     * @param headers            头部消息
     * @param passengersEntities 乘机人信息
     * @param contactEntity      联系人信息
     */
    public RespEntity postContactInfos(String html, String setCookie, Map<String, String> headers, List<PassengersEntity> passengersEntities, ContactEntity contactEntity, String userName) throws IOException {
        Map<String, String> headerMaps = new HashMap<>();
        if (headers != null && headers.size() > 0) {
            for (Map.Entry<String, String> entry : headers.entrySet()) {
                headerMaps.put(entry.getKey(), entry.getValue().toString());
            }
        }
        getOtherCookies(headerMaps);
//        String cookie = headerMaps.get("Cookie");
//        cookie = cookie + ";" + setCookie;
//        headerMaps.remove("Cookie");
//        headerMaps.remove("Referer");
//        headerMaps.remove("Content-Type");
        headerMaps.put("Referer", "https://booking2.airasia.com/Select.aspx");
//        headerMaps.put("Cookie", cookie+";clientipaddr=118.178.15.106");
        System.out.println("修改后的请求的头部消息为----" + JSON.toJSONString(headerMaps));
//        html = HttpClientDownloader.me().getHtml("https://booking2.airasia.com/Traveler.aspx", headerMaps);
//        System.out.println("半路中专的页面为---" + html);
        if (!Jsoup.parse(html).title().contains("Access Denied")) {


            System.out.println("携带来的 头部消息----" + JSON.toJSONString(headerMaps));
            Map<String, String> valueMaps = getListValues(html);
            System.out.println("解析到的表单参数为---" + valueMaps.size());
            valueMaps.remove("MemberLoginTravelerView2$TextBoxUserID");
            valueMaps.put("MemberLoginTravelerView2$TextBoxUserID", userName);

            valueMaps.remove("hdRememberMeEmail", userName);
            valueMaps.put("memberLogin_chk_RememberMe", "on");
            // 联系人信息
            if (contactEntity.getGender().equals("M")) {
                valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$DropDownListTitle", "MR");
            }

            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$TextBoxFirstName", contactEntity.getFirstName());
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$TextBoxLastName", contactEntity.getLastName());
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$TextBoxWorkPhone", contactEntity.getWorkPhone());
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$TextBoxFax", "");
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$TextBoxEmailAddress", contactEntity.getEmail());
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$DropDownListHomePhoneIDC", "93");
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$TextBoxHomePhone", "");
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$DropDownListOtherPhoneIDC", "86");
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$TextBoxOtherPhone", contactEntity.getMobile());
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$EmergencyTextBoxGivenName", "Given name");
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$EmergencyTextBoxSurname", "Family name/Surname");
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$DropDownListMobileNo", "93");
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$EmergencyTextBoxMobileNo", "");
            valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$DropDownListRelationship", "Other");

            // 添加乘机人信息
            if (passengersEntities != null && passengersEntities.size() > 0) {
                for (int i = 0; i < passengersEntities.size(); i++) {
                    //  CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$PassengerInputTravelerView$DropDownListTitle_0:MS  判断是大人还是小孩子
                    PassengersEntity passengersEntity = passengersEntities.get(i);
                    // 成人
                    if (new Integer(0).equals(passengersEntity.getAgeType())) {
                        valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$PassengerInputTravelerView$DropDownListTitle_" + i, "MS");
                    } else if (new Integer(1).equals(passengersEntity.getAgeType())) {
                        // 小孩子
                        valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$PassengerInputTravelerView$DropDownListTitle_" + i, "CHD");
                    } else {
                        return RespEntity.error(RespCode.ORDER_ERROR, "无效的乘客类型");
                    }

                    if (passengersEntity.getGender().equals("M")) {
                        // 男人
                        valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$PassengerInputTravelerView$DropDownListGender_" + i, "1");
                    } else if (passengersEntity.getGender().equals("F")) {
                        // 女人
                        valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$PassengerInputTravelerView$DropDownListGender_" + i, "2");
                    } else {
                        return RespEntity.error(RespCode.ORDER_ERROR, "无效的乘客i性别");
                    }


                    valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$PassengerInputTravelerView$TextBoxFirstName_" + i, passengersEntity.getFirstName());

                    valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$PassengerInputTravelerView$TextBoxLastName_" + i, passengersEntity.getLastName());

                    // 国籍
                    valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$PassengerInputTravelerView$DropDownListNationality_" + i, passengersEntity.getCardIssuePlace());

                    Map<String, Integer> birthday = com.bjlt.spider.util.DateUtil.spiltDateByFormat(passengersEntity.getBirthday(), "yyyy-MM-dd");
                    // 年月 日
                    valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$PassengerInputTravelerView$DropDownListBirthDateDay_" + i, birthday.get("day") + "");
                    valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$PassengerInputTravelerView$DropDownListBirthDateMonth_" + i, birthday.get("month") + "");
                    valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$PassengerInputTravelerView$DropDownListBirthDateYear_" + i, birthday.get("year") + "");
                    valueMaps.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$PassengerInputTravelerView$TextBoxCustomerNumber_" + i, "");


                }
            }

            valueMaps.put("drinkcountname", "[0,0,0,0,0,0,0,0]");
            valueMaps.put("checkBoxInsuranceName", "InsuranceInputControlAddOnsViewAjax$CheckBoxInsuranceAccept");
            valueMaps.put("checkBoxInsuranceId", "CONTROLGROUP_InsuranceInputControlAddOnsViewAjax_CheckBoxInsuranceAccept");
            valueMaps.put("checkBoxAUSNoInsuranceId", "InsuranceInputControlAddOnsViewAjax_CheckBoxAUSNo");
            valueMaps.put("declineInsuranceLinkButtonId", "InsuranceInputControlAddOnsViewAjax_LinkButtonInsuranceDecline");
            valueMaps.put("insuranceLinkCancelId", "InsuranceInputControlAddOnsViewAjax_LinkButtonInsuranceDecline");
            valueMaps.put("radioButtonNoInsuranceId", "InsuranceInputControlAddOnsViewAjax_RadioButtonNoInsurance");
            valueMaps.put("radioButtonYesInsuranceId", "InsuranceInputControlAddOnsViewAjax_RadioButtonYesInsurance");


            Map<String, String> alllFroms = getAllForms(html);
            FileUtil.writeFile("D:/test/联系人页面" + System.currentTimeMillis() + ".html", html, "utf-8", true);
            valueMaps.putAll(alllFroms);
            System.out.println("请求的头部消息为----" + JSON.toJSONString(headerMaps));
            System.out.println("请求的参数为----" + JSON.toJSONString(valueMaps));

            HttpResponse response = OkHttpDownLoader.post("https://booking2.airasia.com/Traveler.aspx").isSsl302Redirects(false).ispost302Rediret(false).addHeaders(headerMaps).param(valueMaps).execute();
            Map<String, Object> responseHeaders = response.getResponseHeaders();
            FileUtil.writeFile("D:/test/联系人结果" + System.currentTimeMillis() + ".html", response.asString(), "utf-8", true);


            System.out.println(JSON.toJSONString(responseHeaders));
        }
        return RespEntity.success(null);
    }


    /**
     * 获取一些不知道有没有用的 setCookie值
     *
     * @param headers
     */
    public static void getOtherCookies(Map<String, String> headers) {


        Map<String, Object> locationMap = OkHttpDownLoader.get("https://booking2.airasia.com/locationfinder?instart_disable_injection=true").addHeaders(headers).execute().getResponseHeaders();

        String sekCookie = "";
        if (locationMap.keySet().contains("Set-Cookie")) {
            sekCookie = locationMap.get("Set-Cookie").toString();
        }
        System.out.println("额外的cookie为---" + sekCookie);


    }


    /**
     * 提交航班列表
     *
     * @param url                请求的地址
     * @param html               页面，用于解析一些提交的值
     * @param headers            头部消息
     * @param fromSegmentValue   去程的valuezhi
     * @param retSegmentValue    回程的值
     * @param orderRequestEntity 生单的实体类
     */
    public HttpResponsePojo postFlightList(String url, String html, Map<String, Object> headers, String fromSegmentValue, String retSegmentValue, OrderRequestEntity orderRequestEntity) {
        HttpResponse httpResponse = null;
        HttpResponsePojo responsePojo = null;

        if (headers != null) {


            try {
                // 转换头部消息的类型
                Map<String, String> headerMaps = new HashMap<>();

                if (headers != null && headers.size() > 0) {
                    for (Map.Entry<String, Object> entry : headers.entrySet()) {
                        headerMaps.put(entry.getKey(), entry.getValue().toString());
                    }
                }
//            headerMaps.remove("Connection");
//            headerMaps.put("Connection","close");
                headerMaps.put("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8");
                // 解析出页面的一些参数
                Map<String, String> otherValues = getListValues(html);
                if (otherValues != null && otherValues.size() > 0) {
                    Map<String, String> froms = Maps.newConcurrentMap();
                    froms.put("__EVENTTARGET", otherValues.get("__EVENTTARGET").toString().trim());
                    froms.put("__EVENTARGUMENT", otherValues.get("__EVENTARGUMENT").toString().trim());
                    froms.put("__VIEWSTATE", otherValues.get("__VIEWSTATE").toString().trim());
                    froms.put("pageToken", otherValues.get("pageToken").toString().trim());
//                froms.put("MemberLoginSelectView$TextBoxUserID", otherValues.get("MemberLoginSelectView$TextBoxUserID").toString().trim());
//                froms.put("hdRememberMeEmail", otherValues.get("hdRememberMeEmail").toString());
//                froms.put("MemberLoginSelectView$PasswordFieldPassword", otherValues.get("MemberLoginSelectView$PasswordFieldPassword").toString().trim());
//                froms.put("memberLogin_chk_RememberMe", otherValues.get("memberLogin_chk_RememberMe").toString().trim());
                    froms.put("MemberLoginSelectView$HFTimeZone", otherValues.get("MemberLoginSelectView$HFTimeZone").trim());
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$AvailabilitySearchInputSelectView$RadioButtonMarketStructure", "RoundTrip");
                    froms.put("ControlGroupAvailabilitySearchInputSelectView_AvailabilitySearchInputSelectVieworiginStation1", orderRequestEntity.getFormCity());
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$AvailabilitySearchInputSelectView$TextBoxMarketOrigin1", orderRequestEntity.getFormCity());
                    froms.put("ControlGroupAvailabilitySearchInputSelectView_AvailabilitySearchInputSelectViewdestinationStation1", orderRequestEntity.getToCity());
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$AvailabilitySearchInputSelectView$TextBoxMarketDestination1", orderRequestEntity.getToCity());
                    String fromDate = orderRequestEntity.getFromDate();
                    String retDate = orderRequestEntity.getRetDate();
                    String fromDateMonth = null;
                    String fromDateDays = null;
                    String retDateMonth = null;
                    String retMonthDays = null;
                    // 把时间拆分出年月和天来
                    if (fromDate.contains("-")) {
                        String[] fromDateStrs = fromDate.split("-");
                        fromDateMonth = fromDateStrs[0] + "-" + fromDateStrs[1];
                        fromDateDays = fromDateStrs[2];
                    }
                    if (retDate != null && retDate.contains("-")) {
                        String[] retDateStrs = retDate.split("-");
                        retDateMonth = retDateStrs[0] + "-" + retDateStrs[1];
                        retMonthDays = retDateStrs[2];
                    }

                    Date dateD = DateUtil.getFormatDate(fromDate, DatePattren.DATE_FORMAT);
//   11/23/2017
                    String fromDatePicker = DateUtil.getFormatDate(dateD, "MM/dd/yyyy");
                    Date dateD2 = DateUtil.getFormatDate(retDate, DatePattren.DATE_FORMAT);
//   11/23/2017
                    String retDatePicker = DateUtil.getFormatDate(dateD2, "MM/dd/yyyy");
                    froms.put("date_picker", fromDatePicker + ",," + retDatePicker + ",");
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$AvailabilitySearchInputSelectView$DropDownListMarketDay1", fromDateDays);
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$AvailabilitySearchInputSelectView$DropDownListMarketMonth1", fromDateMonth);
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$AvailabilitySearchInputSelectView$DropDownListMarketDay2", Integer.parseInt(retMonthDays) + "");
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$AvailabilitySearchInputSelectView$DropDownListMarketMonth2", retDateMonth);
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$AvailabilitySearchInputSelectView$DropDownListPassengerType_ADT", orderRequestEntity.getAdultNum() + "");
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$AvailabilitySearchInputSelectView$DropDownListPassengerType_CHD", orderRequestEntity.getChildNum() + "");
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$AvailabilitySearchInputSelectView$DropDownListPassengerType_INFANT", "0");
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$AvailabilitySearchInputSelectView$DropDownListPassengerType_PWD", "0");
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$AvailabilitySearchInputSelectView$DropDownListPassengerType_SCP", "0");
                    froms.put("ControlGroupAvailabilitySearchInputSelectView$MultiCurrencyConversionViewSelectView$DropDownListCurrency", "default");
                    froms.put("ControlGroupSelectView$AvailabilityInputSelectView$HiddenFieldTabIndex1", "4");
                    froms.put("ControlGroupSelectView$AvailabilityInputSelectView$market1", fromSegmentValue);
                    froms.put("ControlGroupSelectView$AvailabilityInputSelectView$HiddenFieldTabIndex2", "4");
                    froms.put("ControlGroupSelectView$AvailabilityInputSelectView$market2", retSegmentValue);
                    froms.put("ControlGroupSelectView$SpecialNeedsInputSelectView$RadioButtonWCHYESNO", otherValues.get("ControlGroupSelectView$SpecialNeedsInputSelectView$RadioButtonWCHYESNO").toString().trim());
                    froms.put("ControlGroupSelectView$ButtonSubmit", otherValues.get("ControlGroupSelectView$ButtonSubmit").toString().trim());
                    froms.put("__VIEWSTATEGENERATOR", otherValues.get("__VIEWSTATEGENERATOR").toString().trim());
                    log.info("提交航班请求的接口请求参数为----" + JSON.toJSONString(froms));
                    log.info("提交航班请求的接口的请求的头部消息为---" + JSON.toJSONString(headerMaps));
                    System.out.println("提交航班请求的接口请求参数为----" + JSON.toJSONString(froms));
                    System.out.println("提交航班请求的接口的请求的头部消息为---" + JSON.toJSONString(headerMaps));

                    // 进行数据的请求
//
//                HttpRequestPojo requestPojo = new HttpRequestPojo();
//                requestPojo.setUrl(url);
//                requestPojo.setRequestMethod(HttpRequestMethod.POST);
//                 requestPojo.setHeaders(headerMaps);
//                HttpConfig config = new HttpConfig();
//                config.setPost302Rediret(false);
//                requestPojo.setHttpConfig(config);
//                 requestPojo.setFormParam(froms);
//                HttpResponsePojo responsePojo =     HttpClientDownloader.me().postHtml(requestPojo);
                    httpResponse = OkHttpDownLoader.post(url).ispost302Rediret(false).isSsl302Redirects(false).addHeaders(headerMaps).param(froms).execute();
                    if (httpResponse.getResponseHeaders().keySet().contains("Location")) {
                        // 包含跳转信息，说明 到这一步是成功的
                        Map<String, Object> maps = httpResponse.getRequestHeaders();
//                        // 取出cookie值
//                        String cookie = "";
//                        if (maps.keySet().contains("Cookie")) {
//                            cookie = maps.get("Cookie").toString();
//                        }

                        Map<String, Object> lianxirenPaheHeaders = new HashMap<>();
                        lianxirenPaheHeaders.put("Host", "booking2.airasia.com");
                        lianxirenPaheHeaders.put("User-Agent", "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:56.0) Gecko/20100101 Firefox/56.0");
                        lianxirenPaheHeaders.put("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8");
                        lianxirenPaheHeaders.put("Accept-Language", "zh-CN,zh;q=0.8,en-US;q=0.5,en;q=0.3");
                        lianxirenPaheHeaders.put("Accept-Encoding", "gzip, deflate, br");
                        lianxirenPaheHeaders.put("Referer", "https://booking2.airasia.com/Select.aspx");
                        lianxirenPaheHeaders.put("Cookie", httpResponse.getCookies());
                        lianxirenPaheHeaders.put("Connection", "keep-alive");
//                        lianxirenPaheHeaders.put("Upgrade-Insecure-Requests", "1");
                        System.out.println("联系人页面请求的参数---" + JSON.toJSONString(lianxirenPaheHeaders));
//                        String lianxirenHtml = OkHttpDownLoader.get("https://booking2.airasia.com/Traveler.aspx").addHeaders(lianxirenPaheHeaders).execute().asString();
//                        String lianxirenHtml = HttpClientDownloader.me().getHtml("https://booking2.airasia.com/Traveler.aspx",lianxirenPaheHeaders);
//                        FileUtil.writeFile("D:/test/lianxiren_" + System.currentTimeMillis() + ".html", lianxirenHtml, "utf-8", true);

                        String  travelerUrl="https://booking2.airasia.com/Traveler.aspx";//想采集的网址
//                        String refer="http://outofmemory.cn/";
                        URL link=new URL(url);
                        WebClient wc=new WebClient();
                        WebRequest request=new WebRequest(link);
                        request.setCharset("UTF-8");
                        if(lianxirenPaheHeaders != null &&  lianxirenPaheHeaders.size() > 0 ){
                            for(Map.Entry<String,Object> entry : lianxirenPaheHeaders.entrySet()){
                                request.setAdditionalHeader(entry.getKey(), entry.getValue().toString());
                            }
                        }
//                        request.setProxyHost("120.120.120.x");
//                        request.setProxyPort(8080);
//                        request.setAdditionalHeader("Referer", refer);//设置请求报文头里的refer字段
                        ////设置请求报文头里的User-Agent字段
//                        request.setAdditionalHeader("User-Agent", "Mozilla/5.0 (Windows NT 5.1; rv:6.0.2) Gecko/20100101 Firefox/6.0.2");
                        //wc.addRequestHeader("User-Agent", "Mozilla/5.0 (Windows NT 5.1; rv:6.0.2) Gecko/20100101 Firefox/6.0.2");
                        //wc.addRequestHeader和request.setAdditionalHeader功能应该是一样的。选择一个即可。
                        //其他报文头字段可以根据需要添加
                        wc.getCookieManager().setCookiesEnabled(true);//开启cookie管理
                        wc.getOptions().setJavaScriptEnabled(false);//开启js解析。对于变态网页，这个是必须的
                        wc.getOptions().setCssEnabled(true);//开启css解析。对于变态网页，这个是必须的。
                        wc.getOptions().setThrowExceptionOnFailingStatusCode(false);
                        wc.getOptions().setThrowExceptionOnScriptError(false);
                        wc.getOptions().setTimeout(10000);
                        Page page =  wc.getPage(travelerUrl);
                        FileUtil.writeFile("D:/test/001"+System.currentTimeMillis()+".html",page.getWebResponse().getContentAsString(),"utf-8",true);


                    }


                    //
//
//
// System.out.println(responsePojo.getContent());
//                    System.out.println(JSON.toJSONString(httpResponse.getResponseHeaders()));
//                System.out.println(JSON.toJSONString(responsePojo.getHeaders()));
//                FileUtil.writeFile("D:/test/001"+System.currentTimeMillis()+".html",responsePojo.getContent(),"utf-8",true);
                }
            } catch (Exception e) {
                e.printStackTrace();
            }

        }
        return responsePojo;
    }


    /**
     * 获取所有的表单提交参数
     *
     * @param html
     */
    // CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$MealLegInputViewTravelerView$SsrQuantity_passengerNumber_0_ssrCode_PKMX_flightReference_20171123-D7-317-PEKKUL_group_AAXmealCat1_previousSsr_PKMX_dropDown
    public static Map<String, String> getAllForms(String html) throws IOException {
        Map<String, String> result = new HashMap<>();

        if (StringUtil.isNotBlank(html)) {
            Document document = Jsoup.parse(html);
            Elements dynamics = document.select("select.dynamic");
            if (dynamics != null && dynamics.size() > 0) {
                for (Element dynamic : dynamics) {
                    String dynamicName = dynamic.attr("name");
                    // System.out.println("SportEquipInputTravelerView-----" +
                    // dynamicName);
                    // lists.add(dynamicName);
                    result.put(dynamicName, "");
                }
            }

//            System.out.println("------------------------------------------");

            Elements dropdown_styleds = document.select("div.dropdown-styled");
            if (dropdown_styleds != null && dropdown_styleds.size() > 0) {
                for (Element dropdown_styled : dropdown_styleds) {
                    Element selects = dropdown_styled.select("select").get(0);
                    // System.out.println("BaggageLegInputViewTravelerView-----"
                    // + selects.attr("name"));
                    result.put(selects.attr("name"), "");
                }
            }

//            System.out.println("-------------------------------------------");
            Elements ucmealpanel_divSelectedMealsContainers = document
                    .select("div.ucmealpanel-divSelectedMealsContainer");
            if (ucmealpanel_divSelectedMealsContainers != null && ucmealpanel_divSelectedMealsContainers.size() > 0) {
                for (Element ucmealpanel_divSelectedMealsContainer : ucmealpanel_divSelectedMealsContainers) {
                    Elements inputs = ucmealpanel_divSelectedMealsContainer.select("input");
                    if (inputs != null && inputs.size() > 0) {
                        for (Element input : inputs) {
                            // System.out.println(
                            // "ctl00$BodyContent$ucTravelerForm1_form$addOnsPanel1$mealPanel2$SelectedMeal-------"
                            // + input.attr("name"));
                            result.put(input.attr("name"), "");

                        }
                    }
                }
            }

//            System.out.println("----------------------------------------");

            Elements uccomfortkitpanel_item_selections = document.select("div.uccomfortkitpanel-item-selection");
            if (uccomfortkitpanel_item_selections != null && uccomfortkitpanel_item_selections.size() > 0) {
                for (Element uccomfortkitpanel_item_selection : uccomfortkitpanel_item_selections) {
                    Elements inputs = uccomfortkitpanel_item_selection.select("input");
                    if (inputs != null && inputs.size() > 0) {
                        for (Element input : inputs) {
//                            System.out.println(input.attr("name"));
                            // lists.add(input.attr("name"));
                            result.put(input.attr("name"), "0");
                        }
                    }
                    // System.out.println(
                    // "CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ComfortKitInputTravelerView$SsrQuantity_passengerNumber----"
                    // + inputs.get(0).attr("name"));
                    //

                }
            }

//            System.out.println("---------------------------------------------------------------");
            Elements ucmealpanel_item_sf_min_btns = document.select("div.ucmealpanel-item-selection");
            if (ucmealpanel_item_sf_min_btns != null && ucmealpanel_item_sf_min_btns.size() > 0) {
                for (Element ucmealpanel_item_sf_min_btn : ucmealpanel_item_sf_min_btns) {
                    Elements inputs = ucmealpanel_item_sf_min_btn.select("input");
                    if (inputs != null && inputs.size() > 0) {
                        // System.out.println(
                        // "CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$MealLegInputViewTravelerView$SsrQuantity_passengerNumber_1_ssrCode_LSMX_flightReference-------"
                        // + inputs.get(0).attr("name"));

                        for (Element input : inputs) {
                            // lists.add(input.attr("name"));
                            // System.out.println("----" + input.attr("name"));
                            result.put(input.attr("name"), "0");
                        }
                    }

                    Elements as = ucmealpanel_item_sf_min_btn.select("a");

                    if (as != null && as.size() > 0) {

                        for (Element a : as) {
                            // System.out.println("$$$---" + a.attr("name"));
                            // lists.add(a.attr("name"));
                        }

                    }
                }
            }

//            System.out.println("-----------------------------------------------------------");

            // 在这里判断value值是啥
            Elements dropdown_styled_drinks = document.select("div.dropdown-styled-drink");
            if (dropdown_styled_drinks != null && dropdown_styled_drinks.size() > 0) {
                for (Element dropdown_styled_drink : dropdown_styled_drinks) {
                    Elements selects = dropdown_styled_drink.select("select");
                    if (selects != null && selects.size() > 0) {
                        for (Element select : selects) {
                            // System.out.println(
                            // "CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$MealLegInputViewTravelerView$SsrQuantity_passengerNumber----"
                            // + select.attr("name"));
//                            System.out.println("----" + select.attr("name"));
                            String valueStr = select.attr("ssr-data");
                            String value = "";
                            if (valueStr.contains("|")) {

                                String[] valueStrs = valueStr.split("\\|");
                                if (valueStrs != null && valueStrs.length > 0) {
                                    value = valueStrs[0];
                                }

                            }

                            // System.out.println();
                            // lists.add(select.attr("name"));
                            result.put(select.attr("name"), value.split("\\s")[0]);
                        }
                    }
                }
            }
            // System.out.println(lists.size());

        }

        return result;
    }

    /**
     * 获取航班列表
     *
     * @param
     * @return
     */
    public HttpResponse getFlightLists(String html, String cookie, OrderRequestEntity orderRequestEntity) {
        String url = "https://booking2.airasia.com/Search.aspx";
        Map<String, String> headers = new HashMap<>();
        headers.put("Host", "booking2.airasia.com");
        headers.put("User-Agent", "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:56.0) Gecko/20100101 Firefox/56.0");
//		headers.put("Accept","text/html,application/xhtml+xm…plication/xml;q=0.9,*/*;q=0.8");
        headers.put("Accept-Language", "zh-CN,zh;q=0.8,en-US;q=0.5,en;q=0.3");
        headers.put("Accept-Encoding", "gzip, deflate, br");

        headers.put("Referer", "https://booking2.airasia.com/Search.aspx");
        headers.put("Cookie", cookie);
        headers.put("Connection", "keep-alive");
        headers.put("Upgrade-Insecure-Requests", "1");
        log.info("提交的header参数为----" + JSON.toJSONString(headers));

//        String html = null;
        try {
            Map<String, String> values = getListValues(html);
            // 提交的表单信息
            headers.put("Content-Type", "application/x-www-form-urlencoded");

            Map<String, String> froms = new HashMap<>();
            froms.put("__EVENTTARGET", values.get("__EVENTTARGET").toString());
            froms.put("__EVENTARGUMENT", values.get("__EVENTARGUMENT").toString());
            froms.put("__VIEWSTATE", values.get("__VIEWSTATE").toString());
            froms.put("pageToken", values.get("pageToken").toString());
            froms.put("__VIEWSTATEGENERATOR", values.get("__VIEWSTATEGENERATOR").toString());
            froms.put("MemberLoginSearchView$TextBoxUserID", "");
            froms.put("hdRememberMeEmail", "");
            froms.put("MemberLoginSearchView$PasswordFieldPassword", "");
            froms.put("memberLogin_chk_RememberMe", "on");
            froms.put("MemberLoginSearchView$HFTimeZone", "480");
            froms.put("ControlGroupSearchView$AvailabilitySearchInputSearchView$RadioButtonMarketStructure", "RoundTrip");
            froms.put("ControlGroupSearchView_AvailabilitySearchInputSearchVieworiginStation1", orderRequestEntity.getFormCity());
            froms.put("ControlGroupSearchView$AvailabilitySearchInputSearchView$TextBoxMarketOrigin1", orderRequestEntity.getFormCity());
            froms.put("ControlGroupSearchView_AvailabilitySearchInputSearchViewdestinationStation1", orderRequestEntity.getToCity());
            froms.put("ControlGroupSearchView$AvailabilitySearchInputSearchView$TextBoxMarketDestination1", orderRequestEntity.getToCity());
            froms.put("ControlGroupSearchView$MultiCurrencyConversionViewSearchView$DropDownListCurrency", "default");
            String fromDate = orderRequestEntity.getFromDate();
            String retDate = orderRequestEntity.getRetDate();
            String fromDateMonth = null;
            String fromDateDays = null;
            String retDateMonth = null;
            String retMonthDays = null;
            // 把时间拆分出年月和天来
            if (fromDate.contains("-")) {
                String[] fromDateStrs = fromDate.split("-");
                fromDateMonth = fromDateStrs[0] + "-" + fromDateStrs[1];
                fromDateDays = fromDateStrs[2];
            }
            if (retDate != null && retDate.contains("-")) {
                String[] retDateStrs = retDate.split("-");
                retDateMonth = retDateStrs[0] + "-" + retDateStrs[1];
                retMonthDays = retDateStrs[2];
            }
            froms.put("date_picker", fromDate + ",," + retDate + ",");
//         froms.put("date_picker","");

            froms.put("ControlGroupSearchView$AvailabilitySearchInputSearchView$DropDownListMarketDay1", fromDateDays);
            froms.put("ControlGroupSearchView$AvailabilitySearchInputSearchView$DropDownListMarketMonth1", fromDateMonth);
//         froms.put("date_picker","12/05/2017");
//         froms.put("date_picker","");
            froms.put("ControlGroupSearchView$AvailabilitySearchInputSearchView$DropDownListMarketDay2", retMonthDays);
            froms.put("ControlGroupSearchView$AvailabilitySearchInputSearchView$DropDownListMarketMonth2", retDateMonth);
            froms.put("ControlGroupSearchView$AvailabilitySearchInputSearchView$DropDownListPassengerType_ADT", orderRequestEntity.getAdultNum() + "");
            froms.put("ControlGroupSearchView$AvailabilitySearchInputSearchView$DropDownListPassengerType_CHD", orderRequestEntity.getChildNum() + "");
            froms.put("ControlGroupSearchView$AvailabilitySearchInputSearchView$DropDownListPassengerType_INFANT", "0");
            froms.put("ControlGroupSearchView$AvailabilitySearchInputSearchView$DropDownListPassengerType_SCP", "0");
            froms.put("ControlGroupSearchView$AvailabilitySearchInputSearchView$DropDownListPassengerType_PWD", "0");
            froms.put("ControlGroupSearchView$ButtonSubmit", "Search");

            System.out.println("提交的参数为----" + JSON.toJSONString(froms));


            HttpResponse result = OkHttpDownLoader.post(url).addHeaders(headers).param(froms).execute();
            return result;

        } catch (Exception e) {
            return null;

        }

//        System.out.println("列表----" + html);
//        FileUtil.writeFile("D:/亚航列表_2.csv", html, "utf-8", true);


    }

    public RespEntity htmlunitContinue2(String airSource, String url, String cookie) throws IOException {

        Map<String, String> headers = new HashMap<>();
        headers.put("Host", "booking2.airasia.com");
        headers.put("User-Agent", "Mozilla/5.0 (Windows NT 10.0; WOW64; rv:56.0) Gecko/20100101 Firefox/56.0");
        headers.put("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8");
        headers.put("Accept-Language", "zh-CN,zh;q=0.8,en-US;q=0.5,en;q=0.3");
        headers.put("Referer", "https://booking2.airasia.com/AgentHome.aspx");
        headers.put("Accept-Encoding", "gzip, deflate, br");
        headers.put("Connection", "keep-alive");
        String html = null;
        try {
            html = OkHttpDownLoader.get(url).addHeaders(headers).asString();
            return RespEntity.success(html);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return RespEntity.error(RespCode.ORDER_ERROR, url + "---获取页面失败");


    }

    /**
     * 根据id 进行点击并提交
     *
     * @param cookie 登录成功之后的cookie 值
     * @return
     */
    public RespEntity htmlunitContinue(String airSource, String url, String cookie) throws IOException {


//        HtmlunitUtils htmlunitUtils = new HtmlunitUtils();
        try {
            WebClient webClient = new WebClient();
            webClient.getOptions().setJavaScriptEnabled(true);
            ;//启用js 解释器，
            webClient.getOptions().setCssEnabled(false);// 禁止css 支持

            webClient.getOptions().setJavaScriptEnabled(true);
            ;//启用js 解释器，
            webClient.getOptions().setCssEnabled(true);// 禁止css 支持
            // 取出代理ip
            ProxyEntity proxyEntity = null;
            try {
                proxyEntity = ipDao.getIp(airSource, MethodType.ORDER.getTypeName());
                if (proxyEntity != null && StringUtil.isNotBlank(proxyEntity.getIp())) {
                    // 使用代理ip
                    ProxyPojo proxyPojo = new ProxyPojo();
                    proxyPojo.setIp(proxyEntity.getIp());
                    proxyPojo.setPort(proxyEntity.getPort());
//                    htmlunitUtils.setProxy(webClient, new ProxyPojo());
                }
            } catch (Exception e) {
                log.info("使用代理ip出错----" + e);

            }

            webClient.setAjaxController(new NicelyResynchronizingAjaxController()); // 设置Ajax异步处理控制器，即启动Ajax支持
            webClient.getOptions().setThrowExceptionOnScriptError(false); // js运行错误时，是否抛出异常
            webClient.getOptions().setThrowExceptionOnFailingStatusCode(false);// 当出现http error 的时候。程序不抛异常继续执行


            WebRequest webRequest = new WebRequest(new URL(url));
            webRequest.setAdditionalHeader("Cookie", cookie);

            HtmlPage htmlPage = webClient.getPage(webRequest);

            HtmlPage chooseCity = webClient.getPage("https://booking2.airasia.com/Search.aspx");


            Set<Cookie> cookieSets = webClient.getCookieManager().getCookies();
            StringBuffer cookieStr = new StringBuffer();
            if (cookieSets != null && cookieSets.size() > 0) {
                for (Cookie cookieSet : cookieSets) {
                    cookieStr.append(cookieSet.getName() + "=" + cookieSet.getValue() + ";");
                }
            }
            String respContent = chooseCity.getWebResponse().getContentAsString();
            return RespEntity.success(respContent);


        } catch (IOException e) {
            log.error("获取航班列表失败", e);
            RespEntity.error(RespCode.ORDER_ERROR, e);
            throw new IOException(e);
        }

    }


    public Map<String, String> getListValues(String html) {
        String __EVENTTARGET = "";
        String __EVENTARGUMENT = "";
        String __VIEWSTATE = "";
        String pageToken = "";
        String __VIEWSTATEGENERATOR = "";
        String MemberLoginSelectView$TextBoxUserID = "";
        String hdRememberMeEmail = "CNTRIPTOPK_ADMIN";
        String MemberLoginSelectView$PasswordFieldPassword = "";
        String memberLogin_chk_RememberMe = "";
        String MemberLoginSelectView$HFTimeZone = "480";
        // 是否需要轮椅服务  是--RadioButtonWCHYES，否RadioButtonWCHNO

        String ControlGroupSelectView$SpecialNeedsInputSelectView$RadioButtonWCHYESNO = "RadioButtonWCHNO";
        String ControlGroupSelectView$ButtonSubmit = "";
        String HiFlyerFare = "";
        String isAutoSeats = "";
        String CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$CONTROLGROUP_OUTERTRAVELER_CONTROLGROUPTRAVELER_ContactInputTravelerViewHtmlInputHiddenAntiForgeryTokenField = "";
        String CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$HiddenSelectedCurrencyCode = "";
        String HiddenFieldPageBookingData = "";

        Map<String, String> result = new HashMap<>();

//        String html = OkHttpDownLoader.get(url).addHeaders(headers).asString();
        if (StringUtil.isNotBlank(html)) {
            Document document = Jsoup.parse(html);

            try {
                HiddenFieldPageBookingData = document.select("input#HiddenFieldPageBookingDataId").get(0).attr("value");
            } catch (Exception e) {

            }


            try {
                CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$HiddenSelectedCurrencyCode = document.select("input#CONTROLGROUP_OUTERTRAVELER_CONTROLGROUPTRAVELER_ContactInputTravelerView_HiddenSelectedCurrencyCode").get(0).attr("value");
            } catch (Exception e) {

            }


            try {
                CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$CONTROLGROUP_OUTERTRAVELER_CONTROLGROUPTRAVELER_ContactInputTravelerViewHtmlInputHiddenAntiForgeryTokenField = document.select("input#CONTROLGROUP_OUTERTRAVELER_CONTROLGROUPTRAVELER_ContactInputTravelerView_CONTROLGROUP_OUTERTRAVELER_CONTROLGROUPTRAVELER_ContactInputTravelerViewHtmlInputHiddenAntiForgeryTokenField").get(0).attr("value");
            } catch (Exception e) {

            }


            try {
                isAutoSeats = document.select("input[name=isAutoSeats]").get(0).attr("value");
            } catch (Exception e) {

            }


            try {
                HiFlyerFare = document.select("input[name=HiFlyerFare]").get(0).attr("value");
            } catch (Exception e) {

            }
            try {
                MemberLoginSelectView$TextBoxUserID = document.select("input#MemberLoginSelectView_TextBoxUserID").get(0).attr("value");
            } catch (Exception e) {

            }
            try {
                hdRememberMeEmail = document.select("input#hdRememberMeEmail").get(0).attr("value");
            } catch (Exception e) {

            }

            try {
                MemberLoginSelectView$PasswordFieldPassword = document.select("input#MemberLoginSelectView_PasswordFieldPassword").attr("value");
            } catch (Exception e) {

            }

            try {
                memberLogin_chk_RememberMe = document.select("input#memberLogin_chk_RememberMeMemberLogin").get(0).attr("value");
            } catch (Exception e) {

            }

            try {
                MemberLoginSelectView$HFTimeZone = document.select("input#MemberLoginSelectView_HFTimeZone").get(0).attr("value");
            } catch (Exception e) {

            }

            try {
                ControlGroupSelectView$ButtonSubmit = document.select("input#ControlGroupSelectView_ButtonSubmit").get(0).attr("value");
            } catch (Exception e) {

            }
            try {
                __EVENTTARGET = document.select("input#eventTarget").get(0).attr("value");
            } catch (Exception e) {
                // TODO: handle exception
            }
            try {
                __EVENTARGUMENT = document.select("input#eventArgument").get(0).attr("value");
            } catch (Exception e) {
                // TODO: handle exception
            }

            try {
                __VIEWSTATE = document.select("input#viewState").get(0).attr("value");
            } catch (Exception e) {
                // TODO: handle exception
            }

            try {
                pageToken = document.select("input[name=pageToken]").get(0).attr("value");
            } catch (Exception e) {
                // TODO: handle exception
            }

            try {
                __VIEWSTATEGENERATOR = document.select("input#__VIEWSTATEGENERATOR").get(0).attr("value");
            } catch (Exception e) {
                // TODO: handle exception
            }

        }
        result.put("__VIEWSTATEGENERATOR", __VIEWSTATEGENERATOR);
        result.put("__EVENTTARGET", __EVENTTARGET);
        result.put("__EVENTARGUMENT", __EVENTARGUMENT);
        result.put("__VIEWSTATE", __VIEWSTATE);
        result.put("pageToken", pageToken);
        result.put("MemberLoginSelectView$TextBoxUserID", MemberLoginSelectView$TextBoxUserID);
        result.put("hdRememberMeEmail", hdRememberMeEmail);
        result.put("MemberLoginSelectView$PasswordFieldPassword", MemberLoginSelectView$PasswordFieldPassword);
        result.put("memberLogin_chk_RememberMe", memberLogin_chk_RememberMe);
        result.put("MemberLoginSelectView$HFTimeZone", MemberLoginSelectView$HFTimeZone);
        result.put("ControlGroupSelectView$SpecialNeedsInputSelectView$RadioButtonWCHYESNO", ControlGroupSelectView$SpecialNeedsInputSelectView$RadioButtonWCHYESNO);
        result.put("ControlGroupSelectView$ButtonSubmit", ControlGroupSelectView$ButtonSubmit);
        result.put("HiFlyerFare", HiFlyerFare);
        result.put("isAutoSeats", isAutoSeats);
        result.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$CONTROLGROUP_OUTERTRAVELER_CONTROLGROUPTRAVELER_ContactInputTravelerViewHtmlInputHiddenAntiForgeryTokenField", CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$CONTROLGROUP_OUTERTRAVELER_CONTROLGROUPTRAVELER_ContactInputTravelerViewHtmlInputHiddenAntiForgeryTokenField);
        result.put("CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$HiddenSelectedCurrencyCode", CONTROLGROUP_OUTERTRAVELER$CONTROLGROUPTRAVELER$ContactInputTravelerView$HiddenSelectedCurrencyCode);
        result.put("HiddenFieldPageBookingData", HiddenFieldPageBookingData);
        return result;
    }


    /**
     * 进行页面的解析，版本改动2
     *
     * @param html 页面
     * @return
     */
    public List<AirlineInfomation> contentParser2(String html) {
        List<AirlineInfomation> results = Lists.newArrayList();
        if (StringUtil.isNotBlank(html)) {
            Document document = Jsoup.parse(html);

            Elements rgRows = document.select("tr.rgRow");
            if (rgRows != null && rgRows.size() > 0) {
                for (Element rgRow : rgRows) {
//                    System.out.println("-------------------------------------------");
//                    System.out.println(rgRow);
                    if (rgRow != null) {
                        Elements resultFareCell4s = rgRow.select("td.resultFareCell4");
                        if (resultFareCell4s == null || resultFareCell4s.size() <= 0) {
                            resultFareCell4s = rgRow.select("div.resultFare3");
                        }
                        List<Map<String, Object>> lists = Lists.newArrayList();
                        if (resultFareCell4s != null && resultFareCell4s.size() > 0) {
                            for (Element resultFareCell4 : resultFareCell4s) {
//                                System.out.println("*********************************************************");
//                                System.out.println(resultFareCell4);

                                Elements inputs = resultFareCell4.select("input[type=radio]");
                                if (inputs != null && inputs.size() > 0) {
                                    String value = inputs.get(0).attr("value");
                                    Map<String, Object> maps = Maps.newConcurrentMap();
//                                    System.out.println(value);
                                    maps.put("value", value);
                                    String adlutPrice = null;
                                    String childPrice = null;
                                    String curreny = "";

                                    Elements spans = resultFareCell4.select("span");
                                    if (spans != null && spans.size() > 0) {

                                        try {
                                            adlutPrice = spans.get(0).text();
                                            if (StringUtil.isNotBlank(adlutPrice)) {
                                                curreny = CurrencyUtils.currencyIdentification(adlutPrice);
                                            }
                                            adlutPrice = adlutPrice.replace(curreny, "").replace(" ", "").trim();
                                            if (adlutPrice.contains(",")) {
                                                adlutPrice = adlutPrice.replaceAll(",", "");
                                            }
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }
                                        try {
                                            childPrice = spans.get(1).text();
                                            childPrice = childPrice.replace(curreny, "").replace(" ", "").trim();
                                            if (childPrice.contains(",")) {
                                                childPrice = childPrice.replaceAll(",", "");
                                            }
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }
                                    }
//                                    System.out.println(adlutPrice + "|" + childPrice + "|" + curreny);
                                    maps.put("adlutPrice", adlutPrice);
                                    maps.put("childPrice", childPrice);
                                    maps.put("curreny", curreny);
                                    lists.add(maps);

                                }

                            }
                            String cheapValue = priceSore(lists);
                            System.out.println(cheapValue);
                            AirlineInfomation airlineInfomation = new AirlineInfomation();
//                            System.out.println("最便宜的价格value为----"+cheapValue);
                            airlineInfomation.setData(cheapValue);
                            // 然后从这个里面  解析出出发机场，出发时间，到达机场，到达时间，航班号
                            if (cheapValue.contains("|")) {
                                String[] cheapValueSpilts = cheapValue.split("\\|");
                                if (cheapValueSpilts != null && cheapValueSpilts.length > 0) {
                                    String cheapValueSpilt = cheapValueSpilts[1];
//                                    System.out.println(cheapValueSpilt);
                                    // 分航班
                                    if (cheapValueSpilt.contains("^")) {
                                        String[] cheapFlightSpilts = cheapValueSpilt.split("\\^");
                                        List<RouteInfoEntity> routeInfoEntities = Lists.newArrayList();
                                        if (cheapFlightSpilts != null && cheapFlightSpilts.length > 0) {
                                            for (String cheapFlihtSpilt : cheapFlightSpilts) {
//                                             System.out.println("-----------"+cheapFlihtSpilt);
                                                RouteInfoEntity routeInfoEntity = new RouteInfoEntity();
                                                String flightNumber = null;
                                                String depAirport = null;
                                                String depTime = null;
                                                String arrAirport = null;
                                                String arrTime = null;
//                                            System.out.println(cheapFlihtSpilt);
                                                if (cheapFlihtSpilt.contains("~~")) {
                                                    String[] flights = cheapFlihtSpilt.split("~~");
                                                    if (flights != null && flights.length > 1) {
                                                        flightNumber = flights[0].replaceAll("~", "").replaceAll(" ", "");
                                                        String[] flightInfos = flights[1].split("~");
//                                                 System.out.println("*********"+JSON.toJSONString(flightInfos));
                                                        depAirport = flightInfos[0];
                                                        depTime = flightInfos[1];
                                                        arrAirport = flightInfos[2];
                                                        arrTime = flightInfos[3];
                                                        routeInfoEntity.setFlightNumber(flightNumber);
                                                        routeInfoEntity.setDepAirport(depAirport);
                                                        routeInfoEntity.setDepTime(depTime);
                                                        routeInfoEntity.setArrAirport(arrAirport);
                                                        routeInfoEntity.setArrTime(arrTime);
//                                                 System.out.println("-----"+JSON.toJSONString(routeInfoEntity));
                                                        routeInfoEntities.add(routeInfoEntity);
                                                    }
                                                }
                                            }
                                        }
//                                        System.out.println(JSON.toJSONString(routeInfoEntities));
                                        airlineInfomation.setRouteInfoEntities(routeInfoEntities);
                                        results.add(airlineInfomation);
                                    }
                                }
                            }


                        }


                    }


                }


            }

        }


        return results;
    }


    /**
     * 将价格进行排序，然后跳出最便宜的一个
     *
     * @param lists
     */
    public static String priceSore(List<Map<String, Object>> lists) {
        String value = null;
        if (lists != null && lists.size() > 0) {
            List<BigDecimal> prices = Lists.newArrayList();
            List<Map<String, Object>> newprices = Lists.newArrayList();
            for (Map<String, Object> list : lists) {
                BigDecimal priceTotal = new BigDecimal(0);
                String adlutPriceStr = "0";
                BigDecimal adultPrice = new BigDecimal(0);
                String childPriceStr = "0";
                BigDecimal childPrice = new BigDecimal(0);
                try {
                    adlutPriceStr = list.get("adlutPrice").toString();
                    adultPrice = adultPrice.add(new BigDecimal(adlutPriceStr));
                    priceTotal = priceTotal.add(adultPrice);
                } catch (Exception e) {
                    e.printStackTrace();
                }
                try {
                    childPriceStr = list.get("childPrice").toString();
                    childPrice = childPrice.add(new BigDecimal(childPriceStr));
                    priceTotal = priceTotal.add(childPrice);
                } catch (Exception e) {
                    e.printStackTrace();
                }
                prices.add(priceTotal);
                list.put("priceTotal", priceTotal);
                newprices.add(list);

            }
            //将总价格进行排序
            Collections.sort(prices);
            // 根据price的最小值 找出价格对应的value值
            if (prices != null && prices.size() > 0) {
                BigDecimal cheapPrice = prices.get(0);

                if (newprices != null && newprices.size() > 0) {
                    for (Map<String, Object> newprice : newprices) {
                        BigDecimal totalPrice = (BigDecimal) newprice.get("priceTotal");

                        if (cheapPrice.equals(totalPrice)) {
                            value = newprice.get("value").toString();
                        }
                    }
                }


            }


        }

        return value;
    }


    /**
     * 解析页面1,版本改版
     *
     * @param html
     * @return
     */
    public List<AirlineInfomation> contentParser(String html) {
        List<AirlineInfomation> cheapSearchResponseEntitys = new ArrayList<>();
        if (StringUtil.isNotBlank(html)) {
            Document document = Jsoup.parse(html);
            Elements rgRows = document.select("tr.rgRow");
            if (rgRows != null && rgRows.size() > 0) {
                for (Element rgRow : rgRows) {
                    System.out.println("*****************************************************************************************");
                    List<AirlineInfomation> searchResponseEntities = new ArrayList<>();
                    Map<BigDecimal, String> priceMap = new HashMap<>(16);
                    // 取到所有的价格，然后进行比较最低的
                    Elements resultFare3s = rgRow.select("td");
                    if (resultFare3s != null && resultFare3s.size() > 0) {
                        for (Element resultFare3 : resultFare3s) {
                            System.out.println("---------------------------------------------------------------------------------");

                            try {
                                // 寻找下面的input  标签
                                Element inputElement = resultFare3.select("input").get(0);
//                                System.out.println(inputElement);
                                String value = inputElement.attr("value");
                                String productclickdata = inputElement.attr("onclick");
                                if (StringUtil.isBlank(productclickdata)) {
                                    productclickdata = inputElement.attr("productclickdata");
                                }
//                                System.out.println(productclickdata);
                                AirlineInfomation airlineInfomation = getPriceTotal(productclickdata, value, priceMap);
                                searchResponseEntities.add(airlineInfomation);
                            } catch (Exception e) {

                            }

///                            JSONObject
                        }

//                              System.out.println("------------------"+JSON.toJSONString(priceMap));
                        // 取出里面的价格
                        if (priceMap != null && priceMap.size() > 0) {
                            Set<BigDecimal> prices = priceMap.keySet();
                            List<BigDecimal> priceList = new ArrayList<>();
                            for (BigDecimal price : prices) {
                                priceList.add(price);
                            }
//                                  System.out.println("排序前----"+JSON.toJSONString(priceList));
                            Collections.sort(priceList);
//                                  System.out.println("排序后----"+JSON.toJSONString(priceList));
                            String value = priceMap.get(priceList.get(0));
                            for (AirlineInfomation searchResponseEntity : searchResponseEntities) {
                                if (value.equals(searchResponseEntity.getData())) {
//                                           System.out.println("@@@@@@@@@----"+JSON.toJSONString(searchResponseEntity));
                                    cheapSearchResponseEntitys.add(searchResponseEntity);
                                }
                            }


                        }

                    }
                }
            }
        }
//        System.out.println(JSON.toJSONString(cheapSearchResponseEntitys));

        //


        return cheapSearchResponseEntitys;
    }


    /**
     * 计算其中的价格
     *
     * @param productclickdata
     * @param value
     * @param priceMap
     * @return
     */
    public static AirlineInfomation getPriceTotal(String productclickdata, String value, Map<BigDecimal, String> priceMap) {
//        SearchResponseEntity searchResponseEntity = new SearchResponseEntity();
//        searchResponseEntity.setData(value);
        String currency = "";
        // 行程
        AirlineInfomation airlineInfomation = new AirlineInfomation();
        airlineInfomation.setData(value);
        if (StringUtil.isNotBlank(productclickdata)) {
            JSONObject productclickdataObject = JSON.parseObject(productclickdata);
            currency = productclickdataObject.getString("currencyCode");
            String ecommerce = productclickdataObject.getString("ecommerce");
            String click = JSON.parseObject(ecommerce).getString("click");
            String products = JSON.parseObject(click).getString("products");

//            System.out.println(value);
            List<RouteInfoEntity> routeInfoEntities = dataJsonParser(products, value);
            // 将所有的小孩子的价钱和成人的价钱加一起计算总价钱
            if (routeInfoEntities != null && routeInfoEntities.size() > 0) {
                BigDecimal priceTotal = new BigDecimal(0);
                for (RouteInfoEntity routeInfoEntity : routeInfoEntities) {
//                  System.out.println(routeInfoEntity);
                    if (routeInfoEntity.getChildPrice() != null) {
                        priceTotal = priceTotal.add(routeInfoEntity.getChildPrice());
                    }
                    if (routeInfoEntity.getAdultPrice() != null) {
                        priceTotal = priceTotal.add(routeInfoEntity.getAdultPrice());
                    }

                }
                airlineInfomation.setRouteInfoEntities(routeInfoEntities);
                airlineInfomation.setAdultPrice(priceTotal);
                airlineInfomation.setCurrency(currency);

//                System.out.println("总价钱为-----"+priceTotal.toString());
                priceMap.put(priceTotal, value);
            }
//            System.out.println(JSON.toJSONString(routeInfoEntities));

        }
        return airlineInfomation;
    }

    public static List<RouteInfoEntity> dataJsonParser(String dataJson, String value) {
//        System.out.println(value);
        List<Map<String, String>> flights = new ArrayList<>();
        if (value.contains("|")) {
            String[] valueStrs = value.split("\\|");
            if (valueStrs.length > 1) {
                String timeStrs = valueStrs[1];
                if (StringUtil.isNotBlank(timeStrs) && timeStrs.contains("~")) {
                    String[] timeStr = timeStrs.split("~~");
                    if (timeStr.length > 1) {
                        for (int i = 1; i < timeStr.length; i++) {
                            Map<String, String> flight = new HashMap<>();
                            if (StringUtil.isNotBlank(timeStr[i]) && timeStr[i].contains("~")) {
                                String[] times = timeStr[i].split("~");
                                if (times.length >= 4) {
                                    //出发城市
                                    String formCity = null;
                                    // 出发时间
                                    String fromDate = null;
                                    // 到达城市
                                    String toCity = null;
                                    // 到达时间
                                    String retDate = null;
                                    formCity = times[0];
                                    fromDate = times[1];
                                    toCity = times[2];
                                    retDate = times[3];
                                    flight.put("formCity", formCity);
                                    flight.put("fromDate", fromDate);
                                    flight.put("toCity", toCity);
                                    flight.put("retDate", retDate);
                                    flights.add(flight);

                                }
                            }
                        }
                    }
                }
            }
        }

//        System.out.println(flights.size());
        List<RouteInfoEntity> routeInfoEntities = new ArrayList<>();
        if (flights != null && flights.size() > 0) {
            for (Map<String, String> flight : flights) {
                RouteInfoEntity routeInfoEntity = new RouteInfoEntity();
                routeInfoEntity.setDepAirport(flight.get("formCity").toString());
                routeInfoEntity.setDepTime(flight.get("fromDate").toString());
                routeInfoEntity.setArrAirport(flight.get("toCity").toString());
                routeInfoEntity.setArrTime(flight.get("retDate").toString());


                if (StringUtil.isNotBlank(dataJson)) {
                    JSONArray dataArrays = JSON.parseArray(dataJson);
                    if (dataArrays != null && dataArrays.size() > 0) {
                        for (Object dataArray : dataArrays) {

                            String depAirport = JSON.parseObject(dataArray.toString()).getString("dimension2");
                            String arrAirport = JSON.parseObject(dataArray.toString()).getString("dimension3");
                            String variant = JSON.parseObject(dataArray.toString()).getString("id");
                            String price = JSON.parseObject(dataArray.toString()).getString("price");
//                            System.out.println("price---"+price);
                            String cabin = JSON.parseObject(dataArray.toString()).getString("dimension4");
                            String flightNumber = JSON.parseObject(dataArray.toString()).getString("dimension16");
                            String durationStr = JSON.parseObject(dataArray.toString()).getString("dimension61");
                            String arrier = JSON.parseObject(dataArray.toString()).getString("brand");
                            int duration = 0;
                            if (StringUtil.isNotBlank(durationStr) && durationStr.contains("minutes")) {
                                durationStr = durationStr.replace("minutes", "").replace(" ", "").trim();
                                duration = Integer.parseInt(durationStr);
                            }
                            routeInfoEntity.setCarrier(arrier);
                            routeInfoEntity.setCabin(cabin);
                            routeInfoEntity.setFlightNumber(flightNumber);
                            routeInfoEntity.setDuration(duration);
                            if (StringUtil.isNotBlank(depAirport) && StringUtil.isNotBlank(arrAirport) && depAirport.equals(flight.get("formCity")) && arrAirport.equals(flight.get("toCity"))) {
                                //判断是成人还是儿童
                                if (StringUtil.isNotBlank(variant) && variant.contains("Adults")) {

                                    routeInfoEntity.setAdultPrice(new BigDecimal(price));
                                } else if (StringUtil.isNotBlank(variant) && variant.contains("Kids")) {
                                    routeInfoEntity.setChildPrice(new BigDecimal(price));
                                }
                            }


                        }
                    }


                }
                routeInfoEntities.add(routeInfoEntity);
            }


        }
        return routeInfoEntities;
    }

    /**
     * 亚航  web 端的登录，并获取cookie 值
     *
     * @param userName 用户名
     * @param passWord 密码
     */
    public RespEntity airasiaWebLogin(String userName, String passWord) {

        try {

            log.info(userName + "---开始登录");
            WebClient webClient = new WebClient();
            webClient.getOptions().setJavaScriptEnabled(true);
            ;//启用js 解释器，
            webClient.getOptions().setCssEnabled(true);// 禁止css 支持

            webClient.setAjaxController(new NicelyResynchronizingAjaxController()); // 设置Ajax异步处理控制器，即启动Ajax支持
            webClient.getOptions().setThrowExceptionOnScriptError(false); // js运行错误时，是否抛出异常
            webClient.getOptions().setThrowExceptionOnFailingStatusCode(false);// 当出现http error 的时候。程序不抛异常继续执行
            webClient.getOptions().setThrowExceptionOnFailingStatusCode(false);
            webClient.getOptions().setThrowExceptionOnScriptError(false);
            String url = "https://booking2.airasia.com/LoginAgent.aspx";
//            String  userNameStr = "CNTRIPTOPK_ADMIN";
//            String passWordStr = "Tripto123";
            HtmlPage htmlPage = webClient.getPage(url);
//		System.out.println("html---"+htmlPage.asText());
            // 填入用户名和密码
            HtmlInput userNameInput = (HtmlInput) htmlPage.getElementById("ControlGroupLoginAgentView_AgentLoginView_TextBoxUserID");
            userNameInput.setValueAttribute(userName);

            HtmlInput passWordInput = (HtmlInput) htmlPage.getElementById("ControlGroupLoginAgentView_AgentLoginView_PasswordFieldPassword");
            passWordInput.setValueAttribute(passWord);
            log.info("提交的账户为----" + userNameInput.asText() + "---密码为----" + passWordInput.asText());
            // 提交

            HtmlAnchor anchor = (HtmlAnchor) htmlPage.getByXPath(
                    "//*[@id=\"ControlGroupLoginAgentView_AgentLoginView_LinkButtonLogIn\"]").get(0);
            HtmlPage nextPage = anchor.click();
            Set<Cookie> setCookies = webClient.getCookieManager().getCookies();
            StringBuffer cookie = new StringBuffer();
            if (setCookies != null && setCookies.size() > 0) {
                for (Cookie seCookie : setCookies) {
                    cookie.append(seCookie.getName()).append("=").append(seCookie.getValue()).append(";");
                }
            }
            log.info("登录获取到的cookie值为:" + cookie.toString());
            return RespEntity.success(cookie.toString());
//            test("https://booking2.airasia.com/UpdateProfileAgency.aspx", cookie.toString());
            // String nextHtml = nextPage.asText();
            // if(nextHtml.contains("Book a Flight")){
//		 HtmlAnchor nextAnchor = (HtmlAnchor) nextPage.getByXPath("//*[@id=\"UpdateProfileAgency\"]").get(0);
//		 HtmlPage   yanzheng = nextAnchor.click();
//		 System.out.println(yanzheng.asText());
//		 System.out.println("恭喜您，您成功登录");
            //
            // }

        } catch (FailingHttpStatusCodeException e) { // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (MalformedURLException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }


        return RespEntity.error(RespCode.SPIDER_LOGIN_ERROR);

    }


    public static void main(String[] args) {


//        String html = null;
//        try {
//            html = FileUtil.readFile("D:/yahang/shengdanHtml.txt", "utf-8");
//            //    List<String> froms = getAllForms(html);
//
//        } catch (IOException e) {
//            e.printStackTrace();
//        }


        AirasiaWebDAO dao = new AirasiaWebDAO();
        HttpResponse response  =   dao.login("CNTRIPTOPK_ADMIN", "Tripto123");
        System.out.println("----"+response.getCookies());
        String url = "https://booking2.airasia.com/UpdateProfileAgency.aspx";
        Map<String, String> headers = new HashMap<>();
        headers.put("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8");
        headers.put("User-Agent", "Mozilla/5.0 (Windows NT 10.0; WOW64; rv:56.0) Gecko/20100101 Firefox/56.0");
        headers.put("Host", "booking2.airasia.com");
        headers.put("Accept-Language", "zh-CN,zh;q=0.8,en-US;q=0.5,en;q=0.3");
        headers.put("Accept-Encoding", "gzip, deflate, br");
        headers.put("Connection", "keep-alive");
        headers.put("Cookie",response.getCookies());
        String html = OkHttpDownLoader.get(url).addHeaders(headers).execute().asString();
        System.out.println(html);
        //        String cookie = loginResponseHeaders.get("")


//        try {
//            String html = FileUtil.readFile("D:/test/1509624569710.html", "utf-8");
//            List<AirlineInfomation> airlineInfomations = dao.contentParser2(html);
//            System.out.println(JSON.toJSONString(airlineInfomations));
//        } catch (IOException e) {
//            e.printStackTrace();
//        }

//                dao.login("CNTRIPTOPK_ADMIN ","Tripto123");
////      RespEntity cookie =  dao.airasiaWebLogin("CNTRIPTOPK_ADMIN ","Tripto123");
//        try {
////            String html = FileUtil.readFile("D:/test/1509348640760.html", "utf-8");
////            List<AirlineInfomation> airlineInfomations = dao.contentParser2(html);
////            System.out.println("结果为----"+JSON.toJSONString(airlineInfomations));
//            String   lainxirenHtml = FileUtil.readFile("D:/test/联系人.txt","utf-8");
//            ContactEntity contactEntity = new ContactEntity();
//            contactEntity.setGender("MR");
//            contactEntity.setEmail(":");
//            dao.postContactInfos(lainxirenHtml,null,null,null,"");
//        } catch (IOException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
//        }
//        String cookieStr = "acw_tc=AQAAAI6GmCodPA4APQ6VPeo1JzZvJKuo;ASP.NET_SessionId=vfl05nez0u0521455besye55;skysales=1611850762.20480.0000;ASBD=1509078165_9b34c38eb7165a0b1811fd8c619d2d9f;optimizelyDomainTestCookie=0.22642223499163117;optimizelyEndUserId=oeu1509078179239r0.4273263842866649;dtCookie=5$F5D3E5B32474F97E775D78B816DF56F4|RUM+Default+Application|1;rxVisitor=1509091147370K2JIE1AHCQ37CUMOQBEI6PR3GO4CCL6S;dtSa=true%7CC%7C-1%7CLog%20In%7C-%7C1509091155876%7C91147345_268%7Chttps%3A%2F%2Fbooking2.airasia.com%2FLoginAgent.aspx%7CAirAsia%20%5Ep%20Booking%20%5Ep%20Book%20low%20fares%20online%7C1509091147345%7C;i10c_focloir=15:8bf150daa352e264c395b4d86161aac7:0:bf2e3c1b1cea8c82df2e8f3ce3b45f74;dtLatC=1918;rxvt=1509092969340|1509091147387;dtPC=5$91147345_268h-vEROMMKMEOEBMGFLJONOGEIALSJADMXFPPF;__utmt=1;__utma=203916751.1487166379.1509078251.1509078251.1509078251.1;__utmb=203916751.1.10.1509078251;__utmc=203916751;__utmz=203916751.1509078251.1.1.utmcsr=booking2.airasia.com|utmccn=(referral)|utmcmd=referral|utmcct=/AgentHome.aspx;";

//        dao.getFlightLists(null,cookie);
//    String cookieStr = cookie.getAttachment().toString();
//        System.out.println("cookie 为-----"+cookieStr);
//        try {
//            dao.htmlunitContinue(null,"https://booking2.airasia.com/AgentHome.aspx",null
//            ,cookieStr);
//        } catch (MalformedURLException e) {
//            e.printStackTrace();
//        }
    }


    public  HttpResponse    login(String userName, String passWord) {
        Map<String, String> headers = new HashMap<>();
        headers.put("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8");
        headers.put("User-Agent", "Mozilla/5.0 (Windows NT 10.0; WOW64; rv:56.0) Gecko/20100101 Firefox/56.0");
        headers.put("Host", "www.airasia.com");
        headers.put("Accept-Language", "zh-CN,zh;q=0.8,en-US;q=0.5,en;q=0.3");
        headers.put("Accept-Encoding", "gzip, deflate, br");
        headers.put("Connection", "keep-alive");
        HttpResponse Loginresponse = OkHttpDownLoader.get("https://www.airasia.com/cn/zh/login/travel-agent.page").addHeaders(headers).execute();
        Map<String, Object> responseHeaders = Loginresponse.getResponseHeaders();
        String  indexHtml = Loginresponse.asString();
        System.out.println(JSON.toJSONString(responseHeaders));
        if (responseHeaders.keySet().contains("Set-Cookie")) {
            headers.put("Cookie", responseHeaders.get("Set-Cookie").toString());
        }

        headers.put("Content-Type","application/x-www-form-urlencoded");
        headers.put("Referer","https://www.airasia.com/cn/zh/login/travel-agent.page");
        headers.put("Host","booking2.airasia.com");
        Map<String,String> fromsValue = getListValues(indexHtml);
        Map<String,String> froms = new HashMap<>();
        froms.put("TimeZoneDiff","480");
        froms.put("__EVENTTARGET","ControlGroupLoginAgentView$AgentLoginView$LinkButtonLogIn");
        froms.put("__EVENTARGUMENT",fromsValue.get("__EVENTARGUMENT"));
        froms.put("pageToken",fromsValue.get("pageToken"));
        froms.put("ControlGroupLoginAgentView$AgentLoginView$TextBoxUserID",userName);
        froms.put("ControlGroupLoginAgentView$AgentLoginView$PasswordFieldPassword",passWord);
//        System.out.println("提交的参数为---"+JSON.toJSONString(froms));
       HttpResponse response = null;
       try {
           response =     OkHttpDownLoader.post("https://booking2.airasia.com/LoginAgent.aspx").addHeaders(headers).ispost302Rediret(false).isSsl302Redirects(false).param(froms).execute();

       }catch (Exception e){

       }
//               Headers  headers1= OkHttpDownLoader.post("https://booking2.airasia.com/LoginAgent.aspx").addHeaders(headers).param(froms).execute().getRawResponse().headers();

//        System.out.println(JSON.toJSONString(loginResponseHeaders));
         return response;
    }
}
