package com.bjlt.spider.dao;

import com.bjlt.spider.entity.ProxyEntity;
import com.bjlt.spider.interfaces.IpRpc;
import com.bjlt.spider.util.RespEntity;
import com.luyn.core.StringUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

/**
 * auth : luyanan0718@163.com
 * com.bjlt.spider.dao.impl
 * CreateTime:2017/10/12-18:16
 * introduce:
 **/
@Repository
@Slf4j
public class IpDaoImpl  implements IpDao {

    @Autowired
    IpRpc ipRpc;


    /**
     * 获取ip
     * @param channelId  航司 id
     * @param type   类型
     * @return
     */
    @Override
    public ProxyEntity getIp(String channelId, String type) {

       RespEntity respEntity = null;

       ProxyEntity proxyEntity = new ProxyEntity();
       try {
           respEntity = ipRpc.getIPByChannel(channelId,type);
           if(respEntity == null  || respEntity.getStatus() != 200){
               log.error(type+"__"+channelId+"--请求ip 失败，重试。。。");
               //当不成功或者出错的时候，重新请求
               respEntity = ipRpc.getIPByChannel(channelId, type);

           }
           if(respEntity != null){
               String message = respEntity.getAttachment().toString();
               if(StringUtil.isNotBlank(message) &&   message.contains(":")){
                   String[]  mess = message.split(":");
                   if(mess.length  == 2){
                       proxyEntity.setIp(mess[0]);
                       proxyEntity.setPort(Integer.parseInt(mess[1]));

                   }

               }

           }
       }catch (Exception e){

       }

       return proxyEntity;
    }

    /**
     * 返回ip
     * @param channelId
     * @param ip
     */
    @Override
    public void returnIp(String channelId, String ip) {

        try {
            ipRpc.changeIPStatus(channelId, ip);
        } catch (Exception e) {
            e.printStackTrace();
            log.error(channelId+"_"+ip+"__返回失败，重新返回。。。。");
            ipRpc.changeIPStatus(channelId, ip);
        }


    }
}
