package com.bjlt.spider.service.impl;

import com.alibaba.fastjson.JSON;
import com.bjlt.spider.dao.AirasiaWebDAO;
import com.bjlt.spider.entity.*;
import com.bjlt.spider.service.AirasiaWebService;
import com.bjlt.spider.util.RespCode;
import com.bjlt.spider.util.RespEntity;
import com.luyn.core.StringUtil;
import com.luyn.http.httpclient.HttpResponsePojo;
import com.luyn.http.okhttp.response.HttpResponse;
import com.luyn.io.FileUtil;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * auth : luyanan0718@163.com
 * com.bjlt.spider.service.impl
 * CreateTime:2017/10/25-16:14
 * introduce:  亚航 web  端的实现
 **/
@Service
@Slf4j
public class AirasiaWebServiceImpl implements AirasiaWebService {

    @Autowired
    private AirasiaWebDAO airasiaWebDAO = new AirasiaWebDAO();


    /**
     * 亚航 web 端的 生单操作
     *
     * @param orderRequestEntity 生单请求参数
     * @return
     */
    @Override
    public RespEntity order(OrderRequestEntity orderRequestEntity) {
        // 去程
        StringBuffer fromSegmentStr = new StringBuffer();
        // 回程
        StringBuffer retSegmentStr = new StringBuffer();
        List<RouteInfoEntity> fromSegmentRequests = orderRequestEntity.getFromSegments();
        List<RouteInfoEntity> retSegmentRequests = orderRequestEntity.getRetSegments();
        if (fromSegmentRequests != null && fromSegmentRequests.size() > 0) {

            for (RouteInfoEntity fromSegmentRequest : fromSegmentRequests) {
                fromSegmentStr.append(fromSegmentRequest.getDepAirport() + "|" + fromSegmentRequest.getDepTime() + "|" + fromSegmentRequest.getArrAirport() + "|" + fromSegmentRequest.getArrTime() + "|" + fromSegmentRequest.getFlightNumber() + "|");
            }
        }
        if (retSegmentRequests != null && retSegmentRequests.size() > 0) {
            for (RouteInfoEntity retSegmentRequest : retSegmentRequests) {
                retSegmentStr.append(retSegmentRequest.getDepAirport() + "|" + retSegmentRequest.getDepTime() + "|" + retSegmentRequest.getArrAirport() + "|" + retSegmentRequest.getArrTime() + "|" + retSegmentRequest.getFlightNumber() + "|");
            }
        }

        // 此cookie 是从redis 中取出

        log.info(" 1. 开始生单操作。。。。。。。。。。。。。。");
//        RespEntity cookieResp = airasiaWebDAO.airasiaWebLogin("CNTRIPTOPK_ADMIN ", "Tripto123");
//        String cookie = cookieResp.getAttachment().toString();
//        HttpResponse loginResponse = airasiaWebDAO.login("CNTRIPTOPK_ADMIN ", "Tripto123");
//        String cookie = loginResponse.getCookies();
//

        String cookie ="acw_tc=AQAAAOiHuGjmIA0A96d5ewZrN4Ce116K;ASP.NET_SessionId=phvcft55ks55kz45pwixc555;dtCookie=5$73F261B8737A85E887F89B51D1B566EF|RUM+Default+Application|1;skysales=1628627978.20480.0000;ASBD=1509764449_c2b278a7208cc06c8d51591dbc30e01c;i10c_focloir=8:822e66eaa5756e80e7f20ab8f0251f7c:0:cf572be3e0ecb968b8d0e209b5f474c0;";
        System.out.println("登录的cookie为-----" + cookie);
        log.info(" 2 . 当前登录的cookie为---" + cookie);
        // 跳转到选择城市的页面
        String url = "https://booking2.airasia.com/AgentHome.aspx";
        try {
            RespEntity chooseCityHtmlResp = airasiaWebDAO.htmlunitContinue2(orderRequestEntity.getAirSource(), url, cookie);
            System.out.println(chooseCityHtmlResp.getStatus());
            if (chooseCityHtmlResp.getStatus() == 200) {
                log.info("跳转到 选择城市的页面");
                String chooseCityHtml = chooseCityHtmlResp.getAttachment().toString();
                // 选择城市，获取航班了列表内容
                HttpResponse flightContentHttpResponse = airasiaWebDAO.getFlightLists(chooseCityHtml, cookie, orderRequestEntity);
//            String flightContent     = flightContentHttpResponse.asString();

                if (flightContentHttpResponse != null) {
                    // 解析列表内容
                    String flightContentHtml = flightContentHttpResponse.asString();
                    FileUtil.writeFile("d:/test/" + (new Date()).getTime() + ".html", flightContentHtml, "utf-8", true);
                    Map<String, Object> flightContentHeaders = flightContentHttpResponse.getRequestHeaders();   //  选择航班页面的头部消息
//                    Map<String, String> flightContentValueMaps = airasiaWebDAO.getListValues(flightContentHtml); //选择航班页面的 需要提交的一些value 值
                    // 去程的航班的value 值
                    String fromSegmentValue = null;
                    // 回程航班的value 值
                    String retSegmentValue = null;
                    if (StringUtil.isNotBlank(flightContentHtml)) {
                        List<AirlineInfomation> flightLists = airasiaWebDAO.contentParser2(flightContentHtml);

                        System.out.println("解析出来的航班列表-----" + JSON.toJSONString(flightLists));
                        if (flightLists != null && flightLists.size() > 0) {
                            for (AirlineInfomation flightList : flightLists) {
                                List<RouteInfoEntity> flightRouteInfos = flightList.getRouteInfoEntities();
                                // 为了好比对，所以把每个航班的出发时间，出发城市，到达城市，到达时间组合成一个String
                                StringBuffer flightRouteInfoStr = new StringBuffer();
                                if (flightRouteInfos != null && flightRouteInfos.size() > 0) {
                                    for (RouteInfoEntity flightRouteInfo : flightRouteInfos) {
                                        flightRouteInfoStr.append(flightRouteInfo.getDepAirport()).append("|").append(flightRouteInfo.getDepTime()).append("|").append(flightRouteInfo.getArrAirport()).append("|").append(flightRouteInfo.getArrTime()).append("|").append(flightRouteInfo.getFlightNumber()).append("|");

                                    }
                                    System.out.println("航班列表Str---" + flightRouteInfoStr.toString());
                                    System.out.println("去程列表Str----" + fromSegmentStr);
                                    System.out.println("回程列表Str----" + retSegmentStr);
                                    // 判断去程
                                    if (flightRouteInfoStr.toString().equals(fromSegmentStr.toString())) {
                                        fromSegmentValue = flightList.getData();

                                    } else if (flightRouteInfoStr.toString().equals(retSegmentStr.toString())) {
                                        // 回程
                                        retSegmentValue = flightList.getData();

                                    }
                                }


                            }


                            System.out.println("fromSegmentValue" + fromSegmentValue + "______" + "retSegmentValue" + "____" + retSegmentValue);
                            if (StringUtil.isNotBlank(fromSegmentValue) && StringUtil.isNotBlank(retSegmentValue)) {
//                                HttpResponse flightListResponse = airasiaWebDAO.postFlightList("https://booking2.airasia.com/Select.aspx", flightContentHtml, flightContentHeaders, fromSegmentValue, retSegmentValue, orderRequestEntity);
                                HttpResponsePojo flightListResponse = airasiaWebDAO.postFlightList("https://booking2.airasia.com/Select.aspx", flightContentHtml, flightContentHeaders, fromSegmentValue, retSegmentValue, orderRequestEntity);
//                                System.out.println("提交航班信息后的返回头部消息----"+JSON.toJSONString(flightListResponse.getHeaders()));
//                                String flightListContent = flightListResponse.getContent();
//                                FileUtil.writeFile("D:/test/联系人页面"+System.currentTimeMillis()+".html",flightListContent,"utf-8",false);
//
////                                System.out.println(flightListContent);
//                                String  setCoookie = null;
//                                if(flightListResponse.getHeaders().keySet().contains("Set-Cookie")){
//                                 setCoookie =  flightListResponse.getHeaders().get("Set-Cookie").toString();
//                                 if(setCoookie != null && setCoookie.contains(";")){
//                                     setCoookie = setCoookie.split(";")[0];
//                                 }
//                                }
//                                airasiaWebDAO.postContactInfos(flightContentHtml, null,flightListResponse.getRequestPojo().getHeaders(), orderRequestEntity.getPassengersEntities(), orderRequestEntity.getContactEntity(), "CNTRIPTOPK_ADMIN ");











//                          String  flightResponseHtml = flightListResponse.asString();
//                          String  flightResponseHtml = airasiaWebDAO.postFlightList("https://booking2.airasia.com/Select.aspx",flightContentHtml,flightContentHeaders,fromSegmentValue,retSegmentValue,orderRequestEntity);
//                          System.out.println(flightListResponse.asString());
//                          FileUtil.writeFile("D:/test/联系人"+(System.currentTimeMillis())+".html",flightResponseHtml,"utf-8",true);

                            }


                        }

                    }


                } else {
                    return RespEntity.error(RespCode.ORDER_ERROR);
                }

            } else {
                log.error("跳转城市页面失败", chooseCityHtmlResp);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }


        return RespEntity.error(RespCode.ORDER_ERROR);

    }


    public static void main(String[] args) {

        // 测试数据
        OrderRequestEntity orderRequestEntity = new OrderRequestEntity();
        orderRequestEntity.setFormCity("PEK");
        orderRequestEntity.setFromDate("2017-11-23");
        orderRequestEntity.setToCity("TRZ");
        orderRequestEntity.setRetDate("2017-12-03");
        orderRequestEntity.setAdultNum(1);
        orderRequestEntity.setChildNum(1);
        // 中转信息
        // 去程
        RouteInfoEntity routeInfoEntity = new RouteInfoEntity();
        routeInfoEntity.setDepAirport("PEK");
        routeInfoEntity.setDepTime("11/23/2017 02:30");
        routeInfoEntity.setArrTime("11/23/2017 08:55");
        routeInfoEntity.setArrAirport("KUL");
        routeInfoEntity.setFlightNumber("D7317");
        RouteInfoEntity routeInfoEntity2 = new RouteInfoEntity();
        routeInfoEntity2.setDepAirport("KUL");
        routeInfoEntity2.setDepTime("11/23/2017 20:45");
        routeInfoEntity2.setArrTime("11/23/2017 22:00");
        routeInfoEntity2.setArrAirport("TRZ");
        routeInfoEntity2.setFlightNumber("AK23");


        // 回程
        RouteInfoEntity routeInfoEntity3 = new RouteInfoEntity();
        routeInfoEntity3.setDepAirport("TRZ");
        routeInfoEntity3.setDepTime("12/03/2017 22:30");
        routeInfoEntity3.setArrTime("12/04/2017 04:55");
        routeInfoEntity3.setArrAirport("KUL");
        routeInfoEntity3.setFlightNumber("AK22");
        RouteInfoEntity routeInfoEntity4 = new RouteInfoEntity();
        routeInfoEntity4.setDepAirport("KUL");
        routeInfoEntity4.setDepTime("12/04/2017 19:00");
        routeInfoEntity4.setArrTime("12/05/2017 01:15");
        routeInfoEntity4.setArrAirport("PEK");
        routeInfoEntity4.setFlightNumber("D7316");

        List<RouteInfoEntity> fromSegments = new ArrayList<>();
        List<RouteInfoEntity> retSegments = new ArrayList<>();
        fromSegments.add(routeInfoEntity);
        fromSegments.add(routeInfoEntity2);
        retSegments.add(routeInfoEntity3);
        retSegments.add(routeInfoEntity4);
        orderRequestEntity.setFromSegments(fromSegments);
        orderRequestEntity.setRetSegments(retSegments);

        ContactEntity contactEntity = new ContactEntity();
        contactEntity.setEmail("ricky.zeng@tripto.cn");
        contactEntity.setGender("Male");
        contactEntity.setFirstName("ZENG");
        contactEntity.setLastName("GUOQIANG");
        contactEntity.setWorkPhone("861051661680");
        contactEntity.setMobile("18135237517");
        orderRequestEntity.setContactEntity(contactEntity);

        // 乘客信息
        PassengersEntity passengersEntity1 = new PassengersEntity();
        passengersEntity1.setAgeType(0);
        passengersEntity1.setBirthday("1995-07-09");
        passengersEntity1.setCardIssuePlace("CN");
        passengersEntity1.setFirstName("adultFiest");
        passengersEntity1.setLastName("adultLast");
        passengersEntity1.setGender("M");

        PassengersEntity passengersEntity2 = new PassengersEntity();
        passengersEntity2.setAgeType(1);
        passengersEntity2.setBirthday("2009-04-04");
        passengersEntity2.setCardIssuePlace("CN");
        passengersEntity2.setFirstName("childFirst");
        passengersEntity2.setLastName("childLast");
        passengersEntity2.setGender("F");
        List<PassengersEntity> passengersEntities = new ArrayList<>();
        passengersEntities.add(passengersEntity1);
        passengersEntities.add(passengersEntity2);
        orderRequestEntity.setPassengersEntities(passengersEntities);

        // 基本测试数据结束
        AirasiaWebServiceImpl airasiaWebService = new AirasiaWebServiceImpl();
        airasiaWebService.order(orderRequestEntity);
    }

}
